#!/bin/bash

getword()
{
	dd if=$1 bs=4 count=1 skip=$2 2>/dev/null | od -tx1  | grep 0000000 | awk '{print "0x" $5  $4  $3  $2}' | xargs printf "%d\n"
}


w0=$(getword $1 0)
w1=$(getword $1 1)
w2=$(getword $1 2)
w3=$(getword $1 3)
w4=$(getword $1 4)
w5=$(getword $1 5)
w6=$(getword $1 6)
ws=$(expr $w0 + $w1 + $w2 + $w3 + $w4 + $w5 + $w6)
ws=$(expr 0 - $ws)
bs=$(printf "%08X" $ws)

if echo "$ws" | grep "-" >/dev/null
then
	bs=$(echo "$bs" | dd bs=1 skip=8 2>/dev/null)
fi 

b3=$(echo "$bs" | dd bs=1 count=2 skip=0 2>/dev/null)
b2=$(echo "$bs" | dd bs=1 count=2 skip=2 2>/dev/null)
b1=$(echo "$bs" | dd bs=1 count=2 skip=4 2>/dev/null)
b0=$(echo "$bs" | dd bs=1 count=2 skip=6 2>/dev/null)

printf "\x$b0\x$b1\x$b2\x$b3" | dd of=$1 bs=1 seek=28 conv=notrunc 2>/dev/null


