#ifndef _PRC_H_
#define _PRC_H_

//this code does not support PDB files. It could, but does not...
//this code is optimized to read a prc file in order, and provide output
//no appinfo or sortinfo are supported, segmented resource lists are also unsupported

#include <stdbool.h>
#include <stdint.h>

typedef uint32_t (*PrcFileReadF)(void *userData, void *buf, uint32_t len);


#define PALM_DB_ATTR_RESET_AFTER_INSTALL	0x0020

#define PRC_NAME_BUF_SZ			32

//call in order
bool prcOpen(PrcFileReadF readF, void *readD, uint32_t size, char *name, uint16_t *attrP, uint16_t *verP, uint32_t *typeP, uint32_t *cridP, uint16_t *numResP);
bool prcBeginResRead(uint32_t *resTypeP, uint16_t *resIDP, uint32_t *resSizeP);
uint32_t prcContinueResRead(void *bufP, uint32_t space);	//return num bytes read
void prcClose(void);


#endif
